function Data=convertDataToMATLABFast2(ExcelFileName)
%convertData  Converts the data from excel to workspace.
%
%   [Data] = ...
%           convertData(ExcelFileName)
%
%   Converts the data from excel to workspace.
%
excelPath=strcat(pwd,'\',ExcelFileName);
Excel = actxserver ('Excel.Application');
if ~exist(excelPath,'file')
    ExcelWorkbook = Excel.workbooks.Add;
    ExcelWorkbook.SaveAs(excelPath,1);
    ExcelWorkbook.Close(false);
end
invoke(Excel.Workbooks,'Open',excelPath);

%% read excel file
busData = xlsread1(ExcelFileName,'Bus_VAR_VPP1');
busDataInfo = xlsread1(ExcelFileName,'Bus_FX_VPP1');
lineData = xlsread1(ExcelFileName,'Branch_VPP1');
genData = xlsread1(ExcelFileName,'Generator_VAR_VPP1');
genDataID = xlsread1(ExcelFileName,'Generator_FX_VPP1');
loadData=xlsread1(ExcelFileName,'Load_VAR_VPP1');
loadDataID = xlsread1(ExcelFileName,'Load_FX_VPP1');
storageData=xlsread1(ExcelFileName,'Storage_VAR_VPP1');
storageDataID=xlsread1(ExcelFileName,'Storage_FX_VPP1');
v2gData=xlsread1(ExcelFileName,'Vehicle_VAR_VPP1');
v2gDataInfo=xlsread1(ExcelFileName,'Vehicle_FX_VPP1');
marketData=xlsread1(ExcelFileName,'Market_VAR_VPP1');
marketDataInfo=xlsread1(ExcelFileName,'Market_FX_VPP1');
capacitorData=xlsread1(ExcelFileName,'Capacitor_VAR_VPP1');
capacitorDataInfo=xlsread1(ExcelFileName,'Capacitor_FX_VPP1');
MD_systemInfoData = xlsread1(ExcelFileName,'MD_SystemInfo');

%globalParamData = xlsread1(ExcelFileName,'globalParam');
%movSimulatorData = xlsread1(ExcelFileName,'movSimulatorData');
% networkBusDependencies = xlsread1(ExcelFileName,'NetworkBusDependencies');
% networkBusDependencies(:,1)=[];
% networkBusDependencies(1,:)=[];
%Data.networkBusDependencies=networkBusDependencies;
% try 
%     Data.lineData.BIBC = xlsread1(ExcelFileName,'BIBC');
% catch
    
% end
totalStep=MD_systemInfoData(5); % defined manual - TODO automatic 

%% Delete the NaN Value
% Cut the unnecessary values from Generator table
attributesPerGen=max(genData(:,3));
%genData(1,:)=[];
genData(:,1:3)=[];

% Cut the head table from Load table
attributesPerLoad=max(loadData(:,3));
%loadData(1,:)=[];
loadData(:,1:3)=[];

% Cut the head table from storage table
attributesPerStorage=max(storageData(:,3));
%storageData(1,:)=[];
storageData(:,1:3)=[];

% Cut the head table from V2G table
attributesPerV2G=max(v2gData(:,3));
%v2gData(1:3,:)=[];
v2gData(:,1:3)=[];

% Cut the head table from Market table
attributesPerMarket=max(marketData(:,3));
%v2gData(1:3,:)=[];
marketData(:,1:3)=[];

%% conversion from networkData
Data.networkData.branch = lineData(:, [2:3 7:9]);
Data.networkData.lineLimits = lineData(:, [2:3 10]);
Data.networkData.lineLimits(:,end)=Data.networkData.lineLimits(:,end)/(MD_systemInfoData(1));
Data.networkData.networkBusDependencies = getNetworkBusDependencies(Data.networkData.branch);
Data.networkData.busMinVM = busDataInfo(:,6);
Data.networkData.busMaxVM = busDataInfo(:,7);
Data.networkData.busMinAngle = busDataInfo(:,8);
Data.networkData.busMaxAngle = busDataInfo(:,9);
Data.networkData.slackBus = busDataInfo(find(busDataInfo(:,10)),1);
Data.networkData.voltageSlackBus = busData(4:end);

%% conversion from genData and genDataID
genAux=reshape(transp(genData),[totalStep attributesPerGen genDataID(end,1)]);
Data.genData.genPMin=squeeze(genAux(:,1,:))/(MD_systemInfoData(1));
Data.genData.genPMax=squeeze(genAux(:,2,:))/(MD_systemInfoData(1));
Data.genData.genType=squeeze(genAux(:,3,:));
Data.genData.genCofA=squeeze(genAux(:,4,:));
Data.genData.genCofB=squeeze(genAux(:,5,:));
Data.genData.genCofC=squeeze(genAux(:,6,:));
%Data.genData.genContract=squeeze(genAux(:,7,:));
Data.genData.genQMin=squeeze(genAux(:,7,:))/(MD_systemInfoData(1));
Data.genData.genQMax=squeeze(genAux(:,8,:))/(MD_systemInfoData(1));
Data.genData.genCofExc=squeeze(genAux(:,11,:));
Data.genData.genID=genDataID(:,1:2); 
Data.genData.genID(:,3)=transp(Data.genData.genType(1,:)); % ID , BUS , TYPE

%% conversion from loadData and loadDataID
loadAux=reshape(transp(loadData),[totalStep attributesPerLoad loadDataID(end,1)]);
Data.loadData.PLoad=squeeze(loadAux(:,1,:))/(MD_systemInfoData(1));
Data.loadData.PReduce=squeeze(loadAux(:,4,:))/(MD_systemInfoData(1));
Data.loadData.PCut=squeeze(loadAux(:,7,:))/(MD_systemInfoData(1));
Data.loadData.PMove=squeeze(loadAux(:,10,:))/(MD_systemInfoData(1));
Data.loadData.PInMove=squeeze(loadAux(:,13,:))/(MD_systemInfoData(1));
Data.loadData.CofReduce=squeeze(loadAux(:,16,:));
Data.loadData.CofCut=squeeze(loadAux(:,17,:));
Data.loadData.CofMove=squeeze(loadAux(:,18,:));
Data.loadData.CofENS=squeeze(loadAux(:,19,:));
Data.loadData.QLoad=squeeze(loadAux(:,20,:))/(MD_systemInfoData(1));
Data.loadData.CofLoad=squeeze(loadAux(:,23,:));
Data.loadData.loadID=loadDataID(:,1:2);
Data.loadData.totalLoad=sum(Data.loadData.PLoad,2);

%% conversion from storageData and storageDataInfo
storageAux=reshape(transp(storageData),[totalStep attributesPerStorage storageDataID(end,1)]);
Data.storageData.stPPrevState = squeeze(storageAux(:,1,:))/(MD_systemInfoData(1));
Data.storageData.stMaxCharge = squeeze(storageAux(:,2,:))/(MD_systemInfoData(1));
Data.storageData.stMaxDischarge = squeeze(storageAux(:,3,:))/(MD_systemInfoData(1));
Data.storageData.stCapacity = squeeze(storageAux(:,4,:))/(MD_systemInfoData(1));
Data.storageData.stPriceCharge = squeeze(storageAux(:,5,:))/(MD_systemInfoData(1));
Data.storageData.stPriceDischarge = squeeze(storageAux(:,6,:))/(MD_systemInfoData(1));
Data.storageDataInfo = storageDataID(:,1:2); % ID storage, eletrical BUS 
Data.storageDataInfo(:,3) = storageDataID(:,6);%ChargeEfficiency
Data.storageDataInfo(:,4) = storageDataID(:,7);%DischargeEfficiency

%% conversion from marketData
marketAux=reshape(transp(marketData),[totalStep attributesPerMarket marketDataInfo(end,1)]);
Data.marketData.sellPMin=squeeze(marketAux(:,1,:))/(MD_systemInfoData(1));
Data.marketData.sellPMax=squeeze(marketAux(:,2,:))/(MD_systemInfoData(1));
Data.marketData.sellCofA=squeeze(marketAux(:,4,:));
Data.marketData.sellCofB=squeeze(marketAux(:,5,:));
Data.marketData.sellCofC=squeeze(marketAux(:,6,:));
Data.marketDataInfo=marketDataInfo(:,1:2);

%% conversion from v2gData and v2gDataInfo
try
    v2gAux=reshape(transp(v2gData),[totalStep attributesPerV2G v2gDataInfo(end,1)]);
catch
    v2gAux=reshape(transp(v2gData),[totalStep 16 v2gDataInfo(end,1)]);
end
Data.v2gData.v2gPPrevState=squeeze(v2gAux(:,1,:))/(MD_systemInfoData(1));
Data.v2gData.v2gMaxCharge=squeeze(v2gAux(:,2,:))/(MD_systemInfoData(1));
Data.v2gData.v2gMaxDischarge=squeeze(v2gAux(:,3,:))/(MD_systemInfoData(1));
Data.v2gData.v2gPCap=squeeze(v2gAux(:,4,:))/(MD_systemInfoData(1));
Data.v2gData.v2gCofCharge=squeeze(v2gAux(:,5,:));
Data.v2gData.v2gCofDischarge=squeeze(v2gAux(:,6,:));
Data.v2gData.v2gBusNo=squeeze(v2gAux(:,10,:));
Data.v2gData.v2gConnected=squeeze(v2gAux(:,13,:));
Data.v2gData.v2gPMinCharge=squeeze(v2gAux(:,14,:))/(MD_systemInfoData(1));
%Data.v2gData.v2gBatteryCapacity=Data.v2gData.v2gPCap(1,:);
Data.v2gDataInfo=v2gDataInfo(:,[1,3,4]);

%% conversion from parameterData
Data.parameterData.baseMVA=MD_systemInfoData(1); %1/e6
Data.parameterData.basekV=MD_systemInfoData(2); %1/e3
Data.parameterData.baseImpedance=MD_systemInfoData(3);
Data.parameterData.baseCurrent=MD_systemInfoData(4);
Data.parameterData.numPeriods=MD_systemInfoData(5);
Data.parameterData.numBus=MD_systemInfoData(6);
Data.parameterData.numTransformers=MD_systemInfoData(7);
Data.parameterData.numGenerators=MD_systemInfoData(8);
Data.parameterData.numMarkets=MD_systemInfoData(9);
Data.parameterData.numLoads=MD_systemInfoData(10);
Data.parameterData.numStorages=MD_systemInfoData(11);
Data.parameterData.numVehicles=MD_systemInfoData(12);
Data.parameterData.numCapacitors=MD_systemInfoData(13);
Data.parameterData.numExternalSuppliers=MD_systemInfoData(14);

%invoke(Excel.ActiveWorkbook,'Save');
Excel.Quit
Excel.delete
clear Excel

%% conversion of movSimulatorData
%Data.movSimulatorData=movSimulatorData; %commented 15-10-2014

% %% Save bus to mat file - not in use 
% if strfind(ExcelFileName,'.xlsx')
%     strMatFile=strcat(ExcelFileName(1:length(ExcelFileName)-5),'.mat');
%     data.parameterData.strFile=ExcelFileName(1:length(ExcelFileName)-5);
%     save(strMatFile,'data');
% elseif strfind(ExcelFileName,'.xls')
%     strMatFile=strcat(ExcelFileName(1:length(ExcelFileName)-4),'.mat');
%     data.parameterData.strFile=ExcelFileName(1:length(ExcelFileName)-4);
%     save(strMatFile,'data');
% end



