clear all
clc
tTotalTime=tic; % lets track total computational time

 
callDatabase % script to load the caseStudyData
noRuns = 3; % Number of trials here
% get DSA parameters from DSAparameters.m file
DSAparameters

otherParameters = setOtherParameters(caseStudyData,dsaParameters.nParticles);
% set penalties
otherParameters.ensPenalty=10000; % insufficient generation / energy not supplied
otherParameters.voltagePenalty=10000; % bus voltage violations
otherParameters.linesPenalty=10000; % rate capacity of lines violated

[lowerBounds,upperBounds] = setVariablesBounds(caseStudyData,otherParameters);

for iRuns=1:noRuns
    tOpt=tic;
    rand('state',sum(noRuns*100*clock))% ensure stochastic indpt trials
    [ResDB(iRuns).solution, ResDB(iRuns).fitMaxVector, ...
    ResDB(iRuns).objMaxVector, ResDB(iRuns).otherParameters] =...
        DSA(dsaParameters,caseStudyData,otherParameters,lowerBounds,upperBounds);
    ResDB(iRuns).tOpt=toc(tOpt); % time of each trial
    writeBenchTables
end

tTotalTime=toc(tTotalTime)

